// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/PostBody.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class PostBody extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inRubrica = 2;
  public static final int inAfterIntestazione = 4;
  public static final int inAfterRubrica = 6;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3, 3
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\5\0\1\3\10\0\1\4\12\0\1\5\1\6\1\7"+
    "\1\0\1\10\2\0\1\11\1\12\1\13\1\0\1\14"+
    "\1\15\1\16\1\17\1\20\1\0\1\21\1\0\1\22"+
    "\1\23\1\24\1\25\1\0\1\26\1\27\1\30\1\31"+
    "\4\0\1\32\6\0\1\11\1\12\1\13\1\0\1\14"+
    "\1\15\1\16\1\17\1\20\1\0\1\21\1\0\1\22"+
    "\1\23\1\24\1\25\1\0\1\26\1\27\1\30\1\31"+
    "\4\0\1\32\265\0\2\20\115\0\1\27\u0182\0\1\1"+
    "\u0127\0\1\21\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\6\0\3\1\5\2\64\0\1\3\16\0\1\3\5\0"+
    "\1\4\122\0\1\4\7\0\1\3\34\0\1\5\14\0"+
    "\1\6\36\0\1\7\11\0\1\10\4\0\1\11";

  private static int [] zzUnpackAction() {
    int [] result = new int[267];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\33\0\66\0\121\0\154\0\207\0\242\0\275"+
    "\0\330\0\242\0\363\0\u010e\0\u0129\0\u0144\0\u015f\0\u017a"+
    "\0\u0195\0\u01b0\0\u01cb\0\u01e6\0\u0201\0\363\0\u010e\0\u021c"+
    "\0\u0237\0\u0252\0\u026d\0\u0288\0\u02a3\0\u02be\0\u02d9\0\u02f4"+
    "\0\u030f\0\u032a\0\u0345\0\u0360\0\u037b\0\u0396\0\u03b1\0\u03cc"+
    "\0\u03e7\0\u0402\0\u041d\0\u0438\0\u0453\0\u046e\0\u0489\0\u04a4"+
    "\0\u04bf\0\u04da\0\u04f5\0\u0510\0\u052b\0\u0546\0\u0561\0\u057c"+
    "\0\u0597\0\u05b2\0\u05cd\0\u05e8\0\u0603\0\u061e\0\u0639\0\u0654"+
    "\0\u066f\0\u068a\0\242\0\u06a5\0\u06c0\0\u06db\0\u06f6\0\u0711"+
    "\0\u072c\0\u0747\0\u0762\0\u077d\0\u0798\0\u07b3\0\u07ce\0\u07e9"+
    "\0\u0804\0\u081f\0\u083a\0\u0855\0\u0870\0\u088b\0\u08a6\0\u08c1"+
    "\0\u08dc\0\u08f7\0\u0912\0\u092d\0\u0948\0\u0963\0\u097e\0\u0999"+
    "\0\u081f\0\u09b4\0\u09cf\0\u09ea\0\u0a05\0\u0a20\0\u0a3b\0\u0a56"+
    "\0\u0a71\0\u0a8c\0\u0aa7\0\u0ac2\0\u0add\0\u0af8\0\u0b13\0\u0b2e"+
    "\0\u0b49\0\u0b64\0\u0b7f\0\u0b9a\0\u0bb5\0\u0bd0\0\u0beb\0\u0c06"+
    "\0\u0c21\0\u0c3c\0\u0c57\0\u0c72\0\u0c8d\0\u0ca8\0\u0cc3\0\u0cde"+
    "\0\u0cf9\0\u0d14\0\u0d2f\0\u0d4a\0\u0d65\0\u0d80\0\u0d9b\0\u0db6"+
    "\0\u0dd1\0\u0dec\0\u0e07\0\u0e22\0\u0e3d\0\u0e58\0\u0e73\0\u0e8e"+
    "\0\u0ea9\0\u0ec4\0\u0edf\0\u0efa\0\u0f15\0\u0f30\0\u0f4b\0\u0f66"+
    "\0\u0f81\0\u0f9c\0\u0fb7\0\u0fd2\0\u0fed\0\u1008\0\u1023\0\u103e"+
    "\0\u1059\0\u1074\0\u108f\0\u10aa\0\u10c5\0\u10e0\0\u10fb\0\u1116"+
    "\0\u1131\0\u114c\0\u1167\0\u1182\0\u119d\0\u11b8\0\u11d3\0\u11ee"+
    "\0\u1209\0\u1224\0\u123f\0\u125a\0\u1275\0\u1290\0\u12ab\0\u12c6"+
    "\0\242\0\u12e1\0\u12fc\0\u1167\0\u1317\0\u1332\0\u134d\0\u1368"+
    "\0\u1383\0\u139e\0\u13b9\0\u13d4\0\u13ef\0\u140a\0\u1425\0\u1440"+
    "\0\u145b\0\u1476\0\u1491\0\u14ac\0\u14c7\0\u14e2\0\u14fd\0\242"+
    "\0\u1518\0\u1533\0\u154e\0\u1569\0\u1584\0\u159f\0\u15ba\0\u15d5"+
    "\0\u15f0\0\u160b\0\u1626\0\u1641\0\242\0\u165c\0\u1677\0\u1692"+
    "\0\u16ad\0\u16c8\0\u16e3\0\u16fe\0\u1719\0\u1734\0\u174f\0\u176a"+
    "\0\u1785\0\u17a0\0\u17bb\0\u17d6\0\u17f1\0\u180c\0\u1827\0\u1842"+
    "\0\u185d\0\u1878\0\u1893\0\u18ae\0\u18c9\0\u18e4\0\u18ff\0\u191a"+
    "\0\u1935\0\u1950\0\u196b\0\242\0\u1986\0\u19a1\0\u19bc\0\u19d7"+
    "\0\u19f2\0\u1a0d\0\u1a28\0\u1a43\0\u1a5e\0\242\0\u1a79\0\u1a94"+
    "\0\u1aaf\0\u1aca\0\242";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[267];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\7\7\1\10\32\7\1\11\23\7\1\12\2\13\1\14"+
    "\3\12\1\15\24\12\2\13\1\14\3\12\1\16\23\12"+
    "\7\0\1\17\33\0\1\20\61\0\1\21\12\0\1\22"+
    "\2\0\1\23\14\0\1\24\12\0\1\25\14\0\2\26"+
    "\1\27\3\0\1\30\46\0\1\31\13\0\1\32\12\0"+
    "\1\33\2\0\1\34\14\0\1\35\12\0\1\33\17\0"+
    "\1\36\26\0\10\37\1\0\22\37\17\0\1\40\2\0"+
    "\1\41\15\0\1\42\53\0\1\43\23\0\1\44\2\0"+
    "\1\45\15\0\1\46\31\0\1\47\12\0\1\33\25\0"+
    "\1\50\37\0\1\51\2\0\1\52\15\0\1\53\53\0"+
    "\1\54\23\0\1\51\2\0\1\55\27\0\1\56\13\0"+
    "\5\37\1\57\2\37\1\0\22\37\5\0\1\60\53\0"+
    "\1\61\31\0\1\62\26\0\1\63\16\0\1\64\53\0"+
    "\1\65\16\0\1\66\12\0\1\62\24\0\1\51\42\0"+
    "\1\67\10\0\1\70\53\0\1\71\31\0\1\72\26\0"+
    "\1\73\37\0\1\74\11\0\1\75\25\0\5\37\1\57"+
    "\2\37\1\0\10\37\1\76\11\37\25\0\1\77\26\0"+
    "\1\100\12\0\1\101\1\0\1\102\4\0\1\103\27\0"+
    "\1\104\52\0\1\105\26\0\1\106\37\0\1\107\31\0"+
    "\1\110\32\0\1\111\26\0\1\112\12\0\1\113\1\0"+
    "\1\114\4\0\1\115\27\0\1\116\46\0\1\117\36\0"+
    "\1\120\5\0\5\37\1\57\2\37\1\0\15\37\1\121"+
    "\4\37\10\0\1\122\27\0\1\123\25\0\10\101\1\103"+
    "\22\101\23\0\1\124\34\0\1\125\1\126\14\0\1\103"+
    "\27\0\1\127\31\0\1\105\34\0\1\26\34\0\1\130"+
    "\27\0\1\131\25\0\10\113\1\115\22\113\23\0\1\132"+
    "\10\0\2\115\1\133\3\0\1\134\50\0\1\135\12\0"+
    "\1\136\35\0\1\137\22\0\5\37\1\57\2\37\1\0"+
    "\11\37\1\140\10\37\1\0\2\141\1\142\3\0\1\143"+
    "\43\0\1\144\5\0\1\145\16\0\1\146\31\0\1\147"+
    "\52\0\1\150\27\0\1\151\5\0\2\130\1\152\47\0"+
    "\1\153\24\0\1\154\43\0\1\155\13\0\1\156\37\0"+
    "\1\157\47\0\1\160\5\0\2\137\1\161\3\0\1\162"+
    "\23\0\5\37\1\57\1\37\1\163\1\0\22\37\23\0"+
    "\1\164\26\0\1\165\36\0\1\166\40\0\1\167\30\0"+
    "\1\170\31\0\1\171\16\0\1\172\51\0\1\173\24\0"+
    "\1\174\32\0\1\175\36\0\1\176\15\0\1\177\37\0"+
    "\1\200\41\0\1\201\35\0\1\202\24\0\1\203\26\0"+
    "\1\204\13\0\1\37\2\163\2\37\1\57\1\205\1\37"+
    "\1\0\22\37\12\0\1\206\25\0\1\207\55\0\1\210"+
    "\14\0\1\211\45\0\1\212\16\0\1\213\47\0\1\214"+
    "\16\0\1\215\32\0\1\216\50\0\1\217\27\0\1\220"+
    "\34\0\1\221\10\0\1\222\36\0\1\223\33\0\1\224"+
    "\32\0\1\225\25\0\1\226\25\0\5\37\1\57\2\37"+
    "\1\0\14\37\1\227\5\37\27\0\1\230\30\0\1\231"+
    "\21\0\1\232\44\0\1\233\12\0\1\101\42\0\1\234"+
    "\34\0\1\235\40\0\1\236\33\0\1\237\17\0\1\240"+
    "\24\0\1\113\51\0\1\241\32\0\1\242\23\0\1\243"+
    "\42\0\1\244\33\0\1\245\30\0\1\246\5\0\5\37"+
    "\1\57\2\37\1\0\16\37\1\247\3\37\25\0\1\250"+
    "\6\0\1\251\1\0\1\252\4\0\1\253\51\0\1\254"+
    "\23\0\1\255\40\0\1\256\17\0\1\257\37\0\1\260"+
    "\37\0\1\261\34\0\1\262\11\0\1\115\34\0\1\263"+
    "\50\0\1\264\24\0\1\265\37\0\1\266\6\0\1\267"+
    "\1\0\1\270\4\0\1\271\22\0\5\37\1\57\2\37"+
    "\1\0\1\37\1\272\20\37\6\0\1\141\24\0\10\251"+
    "\1\253\22\251\23\0\1\273\10\0\2\274\1\275\3\0"+
    "\1\276\53\0\1\277\15\0\1\300\30\0\1\301\32\0"+
    "\1\302\34\0\1\303\25\0\1\130\54\0\1\304\3\0"+
    "\2\263\1\305\40\0\1\306\34\0\1\307\25\0\1\137"+
    "\24\0\10\267\1\271\22\267\23\0\1\310\7\0\5\37"+
    "\1\57\2\37\1\0\12\37\1\311\7\37\12\0\1\312"+
    "\43\0\1\313\31\0\1\314\21\0\1\315\32\0\1\316"+
    "\36\0\1\317\25\0\1\320\33\0\1\321\32\0\1\322"+
    "\44\0\1\323\24\0\1\324\26\0\1\325\33\0\1\326"+
    "\20\0\3\37\1\163\1\37\1\57\2\37\1\0\22\37"+
    "\27\0\1\327\15\0\1\330\46\0\1\331\36\0\1\332"+
    "\10\0\1\333\46\0\1\334\16\0\1\335\54\0\1\336"+
    "\12\0\1\337\44\0\1\340\16\0\1\7\51\0\1\341"+
    "\30\0\1\342\34\0\1\343\24\0\1\344\31\0\1\345"+
    "\13\0\2\333\1\346\3\0\1\347\23\0\10\350\1\0"+
    "\22\350\20\0\1\351\41\0\1\352\3\0\10\353\1\0"+
    "\22\353\25\0\1\354\13\0\1\251\51\0\1\355\12\0"+
    "\1\356\51\0\1\357\31\0\1\360\13\0\1\361\26\0"+
    "\10\350\1\362\22\350\24\0\1\363\33\0\1\364\5\0"+
    "\10\353\1\7\22\353\6\0\1\267\32\0\1\274\24\0"+
    "\10\365\1\0\22\365\23\0\1\366\21\0\1\367\37\0"+
    "\1\370\14\0\2\362\1\371\3\0\1\372\46\0\1\373"+
    "\15\0\1\263\24\0\10\365\1\374\22\365\14\0\1\375"+
    "\45\0\1\376\10\0\1\377\50\0\1\u0100\13\0\1\u0101"+
    "\42\0\1\325\26\0\1\362\47\0\1\u0102\32\0\1\u0103"+
    "\17\0\1\u0104\37\0\1\u0105\21\0\1\333\34\0\1\u0106"+
    "\51\0\1\u0107\10\0\1\u0108\52\0\1\u0109\32\0\1\u010a"+
    "\13\0\1\362\34\0\1\u010b\22\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[6885];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\6\0\1\11\2\1\1\11\4\1\64\0\1\11\16\0"+
    "\1\1\5\0\1\1\32\0\1\1\67\0\1\1\7\0"+
    "\1\1\5\0\1\11\26\0\1\11\14\0\1\11\36\0"+
    "\1\11\11\0\1\11\4\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[267];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** For the backwards DFA of general lookahead statements */
  private boolean [] zzFin = new boolean [Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())+1];

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	PostBody() { }
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PostBody(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 10: break;
          case 2:
            { yypushback(yylength());
		yybegin(0);
            }
          // fall through
          case 11: break;
          case 3:
            { 
            }
          // fall through
          case 12: break;
          case 4:
            { output.append("\n");
            }
          // fall through
          case 13: break;
          case 5:
            { output.append(yytext());
	yybegin(inRubrica);
            }
          // fall through
          case 14: break;
          case 6:
            { yypushback(yylength()); yybegin(0);
            }
          // fall through
          case 15: break;
          case 7:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 4;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 5;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append("\n");
            }
          // fall through
          case 16: break;
          case 8:
            { yypushback(yylength());
	yybegin(inAfterRubrica);
            }
          // fall through
          case 17: break;
          case 9:
            { yypushback(yylength());
	yybegin(inAfterIntestazione);
            }
          // fall through
          case 18: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java PostBody [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        PostBody scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new PostBody(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
